module Decode
    ( 
      fget_fload,
      ginv,
      ginvz,
      muliomat,
      addiomat,
      fget_f,
      ioreadr,
      fgen_zf2,
      fget_zf2,
      gen_prezf1,
      fget_fc,
      fget_cx_nco,
      fget_iomatarr,
      getiorow,
      fget_fxchain,
      fget_fx,
      fget_fxchain,
      fget_al,
      fget_fchain,
      fget_cx_ncoo,

      --gen_prezf,
    ) where
import Data.List.Split
import Param
import System.IO  
import Mtrx
import Control.Monad
import Data.Matrix
import OpenSSL
import OpenSSL.BN
import File
import Data.Bits


ioreadr :: FilePath -> IO [String]
ioreadr fname = do
      contents <- readFile fname
      return $  lines (spacetonew contents)

spacetonew = map (\c -> if c==' ' then '\n'; else c)

fget_fload :: Parameters -> IO [String]
fget_fload param = do arr <- ioreadr "f"
                      return $ (arr)

fget_al :: Parameters -> [IO (Matrix (Integer))]
fget_al param = loop 1 [(fget_aone_tol param 1)]
    where loop iter arr | iter < ((getl param)) = loop (iter+1) arr++[(fget_aone_tol param iter)]
                        | otherwise = arr
fget_fo :: Parameters -> Integer-> Integer-> Integer -> [IO (Matrix (Integer))] -> IO (Matrix (Integer))
fget_fo param a b amr list 
    | amr == 0 = (addiomat param (list!!(fromInteger a)) (list!!(fromInteger b)))
    | amr == 1 = (muliomat param (list!!(fromInteger a)) (list!!(fromInteger b)))
    | amr == 2 = (list!!(fromInteger a))

--record chain!!!!!!!!!!!!!!
fget_fa :: Parameters -> [Integer] -> [IO (Matrix (Integer))] -> IO (Matrix (Integer))
fget_fa param intructions list = loop 0 list
    where loop iter chain | (intructions!!iter)==2 = (chain!!((length chain)-1))
                          | iter < (length intructions) = loop (iter+3) (chain++[(safemod param(fget_fo param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) chain ))])
                          | otherwise = (chain!!((length chain)-1))


fget_fachain :: Parameters -> [Integer] -> [IO (Matrix (Integer))] -> [IO (Matrix (Integer))] 
fget_fachain param intructions list = loop 0 list
    where loop iter chain | (intructions!!iter)==2 = chain
                          | iter < (length intructions) = loop (iter+3) (chain++[(safemod param(fget_fo param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) chain ))])
                          | otherwise = chain


fget_fchain :: Parameters -> IO [IO (Matrix (Integer))]
fget_fchain param = do intructionsa <- iostrtoiointeger (ioreadr "f")
                       let intructions = (reverse intructionsa)
                       let list = (fget_al param)
                       return $ (fget_fachain param intructions list)


--------------------------------------------------------
fget_fachaing :: Parameters -> Integer -> [Integer] -> [IO (Matrix (Integer))] -> IO (Matrix (Integer))
fget_fachaing param  g intructions list = loop 0 list
    where loop iter chain | iter < (length intructions) = loop (iter+3) (chain++[(fget_fo param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) list )])
                          | otherwise = (chain!!(fromInteger g))
-------------------------------------------------------------------------------  
--fget_fchain :: Parameters -> [IO (Matrix (Integer))]
--fget_fchain param = do intructions <- iostrtoiointeger (ioreadr "f")
--                       let list = (fget_al param)
--                       let output = (fget_fachain param intructions list)
--                       return output


----------------------------------
                     
fget_f :: Parameters -> IO (Matrix (Integer))
fget_f param = do intructionsa <- iostrtoiointeger (ioreadr "f")
                  let intructions = (reverse intructionsa)
                  let list = (fget_al param)
                  output <- (fget_fa param intructions list)
                  return $ output
fget_cx_ncoa param = do cx <- (fget_cx param)
                        return $ (fromList (fromInteger ((getl param)+1)) (fromInteger (getm param)) (toList cx))
fget_cx_nco param = do cx <- fget_cx_ncoa param
                       return $ (submatrix 2 (nrows cx) 1 (ncols cx) cx)

fget_cx_ncoaa param = do cx <- (fget_cx param)
                         return $ (fromList (fromInteger ((getl param)+1)) (fromInteger (getm param)) (toList cx))
fget_cx_ncoo param = do cx <- fget_cx_ncoaa param
                        return $ (submatrix 1 1 1 (ncols cx) cx)
--chaingo

fget_iomatarr :: Parameters ->  IO (Matrix (Integer)) -> [IO (Matrix (Integer))]
fget_iomatarr param iomat = loop 1 [(iomatrow iomat 1)]
    where loop iter arr | iter < ((getl param)+1) = loop (iter+1) arr++[(iomatrow iomat iter)]
                        | otherwise = arr

iomatrow :: IO (Matrix (Integer)) -> Integer -> IO (Matrix (Integer))
iomatrow iomat iter = do mat <- iomat
                         return $  (rowVector (getRow (fromInteger iter ) mat))



fget_fc :: Parameters -> IO (Matrix (Integer))
fget_fc param = do intructionsa <- iostrtoiointeger (ioreadr "f")
                   let intructions = (reverse intructionsa)
                   let list = ((fget_cx_nco param))--fget_iomatarr param ((fget_cx_nco param))
                   output <- (fget_fac param intructions list) --list--fget_fac--(fget_fa param intructions list)
                   return $ output
                   --let list (fget_cx param)
                   --output <- (fget_cx param)--(fget_fa param intructions list)
                   --return $ output

--fget_x


fget_fx :: Parameters -> IO Integer
fget_fx param = do intructionsa <- iostrtoiointeger (ioreadr "f")
                   let intructions = (reverse intructionsa)
                   list <- ((fget_x param))--fget_iomatarr param ((fget_cx_nco param))
                   let output = (fget_fax param intructions list) --list--fget_fac--(fget_fa param intructions list)
                   return $ output

fget_fax :: Parameters -> [Integer] ->  [Integer] -> Integer
fget_fax param intructions list = loop 0 list
    where loop iter chain | (intructions!!iter)==2 = (chain!!((length chain)-1))
                          |iter < (length intructions) = loop (iter+3) ( chain++[(fget_fox param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) chain)])
--(chain++[(fget_fo param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) list )])
                          | otherwise = (chain!!((length chain)-1))--(getiorowl chain)

fget_faxchain :: Parameters -> [Integer] ->  [Integer] ->  [Integer]
fget_faxchain param intructions list = loop 0 list
    where loop iter chain | (intructions!!iter)==2 = chain
                          |iter < (length intructions) = loop (iter+3) ( chain++[(fget_fox param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) chain )])
--(chain++[(fget_fo param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) list )])
                          | otherwise = chain
fget_fxchain :: Parameters -> IO [Integer]
fget_fxchain param = do intructionsa <- iostrtoiointeger (ioreadr "f")
                        let intructions = (reverse intructionsa)
                        list <- ((fget_x param))--fget_iomatarr param ((fget_cx_nco param))
                        let output = (fget_faxchain param intructions list) --list--fget_fac--(fget_fa param intructions list)
                        return $ output


fget_fox :: Parameters -> Integer-> Integer-> Integer -> [Integer]-> Integer
fget_fox param a b amr list 
    | amr == 0 = (list!!(fromInteger a))+(list!!(fromInteger b))
    | amr == 1 = (list!!(fromInteger a))*(list!!(fromInteger b))
    | amr == 2 = (list!!(fromInteger a))

----------

----------------------------------------------
fget_foc :: Parameters -> Integer-> Integer-> Integer -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
fget_foc param a b amr list 
    | amr == 0 = (addiomatc param (getiorow (a+1) list) (getiorow (b+1) list)) --(list!!(fromInteger a)) (list!!(fromInteger b)))
    | amr == 1 = (muliomatc param a b (getiorow (a+1) list) (getiorow (b+1) list)) --(list!!(fromInteger a)) (list!!(fromInteger b)))
    | amr == 2 = (getiorowl list)--(getiorow (a+1) list)

addiomatc :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
addiomatc param iomata iomatb = do mata <- iomata
                                   matb <- iomatb
                                   return $ (safemodmat param (elementwise add mata matb))

muliomatc :: Parameters -> Integer -> Integer -> IO (Matrix (Integer)) -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
muliomatc param a b iomata iomatb = do mata <- iomata
                                       matb <- iomatb
                                       xarr <- fget_fxchain param
                                       arr <-  fget_fchain param
                                       a_a <- (arr!!(fromInteger a))
                                       let a_aginv = ginv param a_a
                                       return $ (safemodmat param (elementwise add (multStd mata a_aginv) (scaleMatrix ((xarr!!(fromInteger b)))matb)))--(multStd mata (ginv param matb))
--record chain!!!!!!!!!!!!!!
fget_fac :: Parameters -> [Integer] -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
fget_fac param intructions list = loop 0 list
    where loop iter chain | (intructions!!iter)==2 = getiorowl chain
                          |iter < (length intructions) = loop (iter+3) (combineiomatrix chain (fget_foc param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) list ))
--(chain++[(fget_fo param (intructions!!(iter+1)) (intructions!!(iter+2)) (intructions!!iter) list )])
                          | otherwise = getiorowl chain--(getiorowl chain)
combineiomatrix :: IO (Matrix (Integer)) -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
combineiomatrix iomata iomatb = do mata <- iomata
                                   matb <- iomatb
                                   return $ (mata <-> matb)

getiorow :: Integer -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
getiorow row iomat = do mat <- iomat
                        return $ (rowVector (getRow (fromInteger row) mat))

getiorowl ::  IO (Matrix (Integer)) -> IO (Matrix (Integer))
getiorowl iomat = do mat <- iomat
                     return $ (rowVector (getRow ((nrows mat)) mat))
-------------------------------------------------------------------------


fgen_zf2 :: Parameters -> IO()
fgen_zf2 param = genrandinta param "zf2" ((getm param))


fget_zf2 :: Parameters -> IO (Matrix (Integer))
fget_zf2 param = do  iointarr <- iostrtoiointeger (ioread "zf2")
                     return $ (fromList (fromInteger (getm param)) (fromInteger (1)) (iointarr))


gen_prezf1 :: Parameters -> IO (Matrix (Integer))
gen_prezf1 param = do af <-fget_f param
                      zf1 <-fget_zf2 param
                      u <- fget_u param
                      return $ (elementwise add (multStd af zf1) ((minusmat param (zero (nrows u) (ncols u)) u)))

------------------------------
-- #hashtag
--(zf1 <-> zf2)
-------------------------------------------------------------------------
addiomat :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
addiomat param iomata iomatb = do mata <- iomata
                                  matb <- iomatb
                                  return $ (elementwise add mata matb)

muliomat :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
muliomat param iomata iomatb = do mata <- iomata
                                  matb <- iomatb
                                  return $ (multStd mata (ginv param matb))


ioginv :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
ioginv param iomat = do mat <-iomat
                        return $ (ginv param mat)

ginva :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer))
ginva param mat = loop 1 mat
    where loop x arr | x <(getl param) = loop (x+1) (arr <|> mat) 
                     | otherwise = (fromList (2*(fromInteger(getl param))*(nrows mat)) (ncols mat) (toList (arr <|> arr))) 

ginvb :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer))
ginvb param mat = loop 1 2 [(toInteger (ginv_elem param mat 1 1))]
    where loop x y arr | x<((nrows mat)+1) = if (y< ((ncols mat))) then loop x (y+1) (arr++[(toInteger (ginv_elem param mat x y))])  else loop (x+1) (1) (arr++[(toInteger (ginv_elem param mat x y))]) 
                       | otherwise = (fromList (nrows mat) (ncols mat) arr)
ginv :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer))
ginv param mat =  ginvb  param (ginva param mat)

--------------------------------------------------





ginvaz :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer))
ginvaz param mat = loop 1 mat
    where loop x arr | x <(getl param) = loop (x+1) (arr <|> mat) 
                     | otherwise = (fromList ((fromInteger(getl param))*(nrows mat)) (ncols mat) (toList (arr ))) 

ginvbz :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer))
ginvbz param mat = loop 2 [(toInteger (ginv_elem param mat 1 1))]
    where loop x arr | x<((nrows mat)+1) = loop (x+1)  (arr++[(toInteger (ginv_elemz param mat x 1))]) 
                     | otherwise = (fromList (nrows mat) (ncols mat) arr)


ginvz :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer))
ginvz param mat =  ginvbz  param (ginvaz param mat)



ginv_elemaz :: Parameters -> (Matrix (Integer)) -> Int-> Int-> Integer
ginv_elemaz param mat x y = toInteger ( (.&.) (getElem ( x) ( y)  mat) ((2^(mod (x-1) (fromInteger((getl param)))))) )

ginv_elemz :: Parameters -> (Matrix (Integer)) -> Int-> Int-> Integer
ginv_elemz param mat x y = if (ginv_elemaz param mat x y)==0 then 0 else 1

--------------------------------------------------

ginv_elema :: Parameters -> (Matrix (Integer)) -> Int-> Int-> Integer
ginv_elema param mat x y = toInteger ( (.&.) (getElem ( x) ( y)  mat) ((2^(mod (x-1) (fromInteger(2*(getl param)))))) )

ginv_elem :: Parameters -> (Matrix (Integer)) -> Int-> Int-> Integer
ginv_elem param mat x y = if (ginv_elema param mat x y)==0 then 0 else 1

--(toInteger (getElem (fromInteger x) (fromInteger y)  mat))    (fromInteger (2^(mod (x-1) (getl param))))   ))












