module File
    ( iowrite,
      calc,
      writeri,
      saveArr,
      ioread,
      iostrtoiointeger,
      genrandinta,
      fget_abar,
      fget_h,
      fgen_h,
      fgen_abar,
      fgen_g,
      fget_g,
      fgen_rbar,
      fget_rbar,
      fget_r,
      fget_arbar,
      fmod,
      safemod,
      fget_hg,
      fget_a,
      checktozero,
      fget_secparta,
      fget_ar,
      fgen_aone_tol,
      fget_aone_tol,
      fgen_u,
      fget_u,
      fgen_s,
      fget_s,
      fgen_x,
      fget_x,
      fgen_pree,
      fgen_preo,
      fget_pree,
      fget_preo,
      fget_e,
      fgen_mu,
      fget_mu,
      gen_bh,
      fgen_bh,
      fget_bh,
      fgen_gg,
      fget_gg,
      minusiomat,
      minusmat,
      fmodmat,
      gen_cx1,
      fgen_cx1,
      fget_cx1,
      gen_cx2,
      fgen_cx2,
      fget_cx2,
      fget_cx,
      add,
      genrandintapm,
      stringiointnpm,
      strtointeger,
      fstoreiomatrix,
      fstorematrix,
      safemodmat
    ) where
import Data.List.Split
import Param
import System.IO  
import Mtrx
import Control.Monad
import Data.Matrix
import OpenSSL
import OpenSSL.BN


--import Numeric.Matrix

-----------------------------------------
fget_cxpre :: Parameters -> IO (Matrix (Integer))
fget_cxpre param = do cx1 <- fget_cx1 param
                      cx2 <- fget_cx2 param
                      return $ cx1 <-> cx2

fget_cx :: Parameters -> IO (Matrix (Integer))
fget_cx param = safemod param (fget_cxpre param)


gen_cx2 :: Parameters -> IO (Matrix (Integer))
gen_cx2 param = do s <- (fget_s param)
                   u <- (fget_u param)
                   m <- (iomulq param (fget_m param))--(fget_m param)
                   return $ (elementwise add (multStd (transpose s) u) m   )

iomulq :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
iomulq param iomat = do mat <- iomat
                        return $ (fromList (nrows mat) (ncols mat) (mulq param  (Data.Matrix.toList mat)))

mulq :: Parameters -> [Integer] -> [Integer]
mulq param mat = loop 0 []
    where loop iter output | iter <(length mat) = loop (iter+1) output++[((mat!!iter)*((quot (getq param) 2)+1))]
                           | otherwise = output

fget_m :: Parameters -> IO (Matrix (Integer))
fget_m param = do  iointarr <- iostrtoiointeger (ioread "m")
                   return $ ((fromList (fromInteger 1) (fromInteger 1) (iointarr)))

fgen_cx2 :: Parameters -> IO ()
fgen_cx2 param = fstoreiomatrix (gen_cx2 param)"cx2"


fget_cx2 :: Parameters -> IO (Matrix (Integer))
fget_cx2 param = do  iointarr <- iostrtoiointeger (ioread "cx2")
                     return $ ((fromList (fromInteger 1) (fromInteger 1) (iointarr)))

gen_cx1 :: Parameters -> IO (Matrix (Integer))
gen_cx1 param = do print $ "testa"
                   bh <- (fget_bh param)
                   print $ "testb"
                   s <- (fget_s param)
                   e <- (fget_e param)
                   return $ elementwise add (multStd (transpose bh) s) e

fgen_cx1 :: Parameters -> IO ()
fgen_cx1 param = do print $ "aa"
                    fstoreiomatrix (gen_cx1 param) "cx1"
--fstoreiomatrix iomat file
fget_cx1 :: Parameters -> IO (Matrix (Integer))
fget_cx1 param = do  iointarr <- iostrtoiointeger (ioread "cx1")
                     return $ (fromList (fromInteger (((getl param)+1)*((getm param)))) (fromInteger 1) (iointarr))





add :: (Integer) -> (Integer) -> (Integer)
add a b = a+b
--elementwise + (multStd (transpose (fget_bh param)) (fget_s param)) (fget_e param)

---------------------------------------

fmodarr :: Parameters -> [Integer] -> [Integer]
fmodarr param arr = loop 0 []
    where loop iter output | iter < (length arr) = loop (iter +1) output ++[(mod (arr!!iter) (getq param))]
                           | otherwise = output
--fmodarrio :: Parameters -> IO [Integer] -> IO [Integer] 
--fmodarrio param ioarr = do ar <- ioarr
--                           return $ (fmodarr param ioarr)
fmodmat :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer))
fmodmat param mat = fromList (nrows mat) (ncols mat) (fmodarr param  (Data.Matrix.toList mat))

safemodmat :: Parameters -> (Matrix (Integer)) ->(Matrix (Integer))
safemodmat param iomat = (fmodmat param (fmodmat param iomat))


fmod :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
fmod param iomat = do mat <- iomat
                      return $ (fmodmat param mat)

safemod :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
safemod param iomat = (fmod param (fmod param iomat))

--fromList (nrows mat) (ncols mat) (fmodarrio param  (Data.Matrix.toList mat))

---------------------------------------------------------------------------------------
onpof :: Integer -> Integer
onpof a =2*a-1

onof :: Integer -> Integer
onof a =2*a-1

returnonof:: Parameters -> IO Integer
returnonof param = do
                  rand <- (randIntegerZeroToNMinusOne 2)
                  return $ (onof rand)

returnoo:: Parameters -> IO Integer
returnoo param = do
                  rand <- (randIntegerZeroToNMinusOne 2)
                  return $ (rand)


randq :: Parameters -> IO Integer
randq param = prandIntegerZeroToNMinusOne (getq param)


stringioint :: Parameters -> IO String
stringioint param = do
    a <- randq param
    return $ (show a)

stringiointpm :: Parameters -> IO String
stringiointpm param = do
    a <-returnonof param
    return $ (show a)

stringiointpmoo :: Parameters -> IO String
stringiointpmoo param = do
    a <-returnoo param
    return $ (show a)

stringiointnpmoo :: Parameters -> Integer -> IO String
stringiointnpmoo param num = loop 1 (stringiointpmoo param)
    where loop iter string | iter<num = loop (iter+1) (addiostr string (stringiointpmoo param))
                           | otherwise = string


stringiointnpm :: Parameters -> Integer -> IO String
stringiointnpm param num = loop 1 (stringiointpm param)
    where loop iter string | iter<num = loop (iter+1) (addiostr string (stringiointpm param))
                           | otherwise = string

stringiointn :: Parameters -> Integer -> IO String
stringiointn param num = loop 1 (stringioint param)
    where loop iter string | iter<num = loop (iter+1) (addiostr string (stringioint param))
                           | otherwise = string

genrandinta param name number = do
    --a <- prandIntegerZeroToNMinusOne  5
    --b <- prandIntegerZeroToNMinusOne  5
    --writeFile "some-file.txt" (stringrep 10 (show (a)))
    output <-(stringiointn param number)
    writeFile name output

genrandintaoo param name number = do
    --a <- prandIntegerZeroToNMinusOne  5
    --b <- prandIntegerZeroToNMinusOne  5
    --writeFile "some-file.txt" (stringrep 10 (show (a)))
    output <-(stringiointnpmoo param number)
    writeFile name output

genrandintapm param name number = do
    --a <- prandIntegerZeroToNMinusOne  5
    --b <- prandIntegerZeroToNMinusOne  5
    --writeFile "some-file.txt" (stringrep 10 (show (a)))
    output <-(stringiointnpm param number)
    writeFile name output


ioread :: FilePath -> IO [String]
ioread fname = do
    contents <- readFile fname
    return $  lines contents

iostrtoiointeger :: IO [String] -> IO [Integer]
iostrtoiointeger iostrarr = do strarr <- iostrarr
                               return $ strarr2intarr strarr
strtointeger :: [String] -> [Integer]
strtointeger strarr = strarr2intarr strarr
fgen_abar :: Parameters -> IO()
fgen_abar param = genrandinta param "a_bar" ((getn param)*(getmb param))

fgen_rbar :: Parameters -> IO()
fgen_rbar param = genrandintapm param "r_bar" ((getmb param)*(getw param))


fgen_h :: Parameters -> IO()
fgen_h param = genrandintapm param "h" ((getn param)*(getn param))


fget_abar :: Parameters -> IO (Matrix (Integer))
fget_abar param = do  iointarr <- iostrtoiointeger (ioread "a_bar")
                      return $ (fromList (fromInteger (getn param)) (fromInteger (getmb param)) (iointarr))

fget_rbar :: Parameters -> IO (Matrix (Integer))
fget_rbar param = do  iointarr <- iostrtoiointeger (ioread "r_bar")
                      return $ (fromList (fromInteger (getmb param)) (fromInteger (getw param)) (iointarr))
------------------------------------------------------------
--this is for bigh
fstoreiomatrix :: IO (Matrix (Integer)) -> String -> IO ()
fstoreiomatrix iomat file = do mat <- iomat
                               writeFile file (arr2str  (Data.Matrix.toList mat) )

fstorematrix :: (Matrix (Integer)) -> String -> IO ()
fstorematrix iomat file = do let mat = iomat
                             writeFile file (arr2str  (Data.Matrix.toList mat) )
                               --fstorematrix (Data.Matrix.toList mat) file

arr2str :: [Integer] -> String 
arr2str arr  = loop 0 ""
    where loop iter output | iter < (length arr) = loop (iter+1) output++"\n"++(show (arr!!iter))
                           | otherwise = output


--writeFile file "hello" ice
--fget_x:: Parameters -> IO ([Integer])

combineiomat :: IO (Matrix (Integer)) -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
combineiomat mata matb = do a <- mata
                            b <- matb
                            return $ a <|> b


--fucked
subh :: Parameters -> Integer -> IO (Matrix (Integer))
subh param iter = do x <- fget_x param
                     if ((x!!((fromInteger iter)-1))==0) then (fget_aone_tol param iter) else (fmod param ( minusiomat param (fget_gg param) (fget_aone_tol param iter)))
                     

gen_bh :: Parameters -> IO (Matrix (Integer))
gen_bh param = loop 1 (fget_a param)
    where loop iter output | iter < ((getl param)+1) = loop (iter+1) (combineiomat output ( (subh param iter)))
                           | otherwise = output


fgen_bh :: Parameters -> IO ()
fgen_bh param = fstoreiomatrix (gen_bh param) "bh" 

--fget_bh :: Parameters -> IO (Matrix (Integer))
--fget_bh param = do  iointarr <- iostrtoiointeger (ioread "bh")
--                    return $ (fromList (fromInteger (getn param)) (fromInteger (((getl param)+1)*(getm param))) (iointarr))
                    --return $ (fromList (fromInteger (getn param)) (fromInteger (((getl param)+1)*(getm param))) (iointarr))


fget_bh :: Parameters -> IO (Matrix (Integer))
fget_bh param = do  iointarr <- iostrtoiointeger (ioread "bh")
                    return $ ((fromList (fromInteger (getn param)) (fromInteger (((getl param)+1)*(getm param))) (iointarr)))


------------------------------------------------------------
--this is for e

fgen_pree :: Parameters -> IO()
fgen_pree param = genrandintapm param "pree" ((getm param)*(getm param)*(getl param))

fgen_preo :: Parameters -> IO()
fgen_preo param = genrandintapm param "eo" ((getm param))


fget_pree :: Parameters -> IO (Matrix (Integer))
fget_pree param = do  iointarr <- iostrtoiointeger (ioread "pree")
                      return $ (fromList (fromInteger (getm param)) ((fromInteger (getl param))*(fromInteger (getm param))) (iointarr))


fget_preo :: Parameters -> IO (Matrix (Integer))
fget_preo param = do  iointarr <- iostrtoiointeger (ioread "eo")
                      return $ (fromList (fromInteger (getm param)) ((fromInteger (1))) (iointarr))
fgen_pre1 :: Parameters -> IO()
fgen_pre1 param = genrandintapm param "e1" ((getm param))

fget_pre1 :: Parameters -> IO (Matrix (Integer))
fget_pre1 param = do  iointarr <- iostrtoiointeger (ioread "e1")
                      return $ (fromList (fromInteger (getm param)) ((fromInteger (1))) (iointarr))


fget_e :: Parameters -> IO (Matrix (Integer))
fget_e param = do let id = identity (fromInteger (getm param))
                  pre <- fget_pree param
                  eo <- fget_preo param
                  return $ ((fromList (fromInteger ((getm param)*((getl param+1)))) (fromInteger (1)) (Data.Matrix.toList (multStd (transpose (id <|> pre)) eo))))

------------------------------------------------------------
--stringiointnpmoo :: Parameters -> Integer -> IO String
fgen_x :: Parameters -> IO()
fgen_x param = genrandintaoo param "x" ((getl param))

fget_x:: Parameters -> IO ([Integer])
fget_x param = do  iointarr <- iostrtoiointeger (ioread "x")
                   return $ iointarr


fgen_mu :: Parameters -> IO()
fgen_mu param = genrandintaoo param "mu" ((1))

fget_mu:: Parameters -> IO ([Integer])
fget_mu param = do  iointarr <- iostrtoiointeger (ioread "mu")
                    return $ iointarr

--------------------------------------------------------
fgen_u :: Parameters -> IO()
fgen_u param = genrandinta param "u" ((getn param))

fget_u:: Parameters -> IO (Matrix (Integer))
fget_u param = do  iointarr <- iostrtoiointeger (ioread "u")
                   return $ (fromList (fromInteger (getn param)) (fromInteger (1)) (iointarr))

fgen_s :: Parameters -> IO()
fgen_s param = genrandinta param "s" ((getn param))

fget_s:: Parameters -> IO (Matrix (Integer))
fget_s param = do  iointarr <- iostrtoiointeger (ioread "s")
                   return $ (fromList (fromInteger (getn param)) (fromInteger (1)) (iointarr))

--------------------------------------------------------
--gen A_1 to A_l

fgen_aone_tol :: Parameters -> IO()
fgen_aone_tol param = genrandinta param "a_onetol" ((getl param)*(getn param)*(getm param))

getsuba :: Parameters -> Integer -> [Integer] -> [Integer]
getsuba param num arr = loop ((num-1)*(getn param)*(getm param)) []
    where loop iter output | iter < (num)*(getn param)*(getm param) = loop (iter+1) output++[(arr!!(fromInteger iter))]
                           | otherwise = output

fget_aone_tol:: Parameters -> Integer -> IO (Matrix (Integer))
fget_aone_tol param num= do  iointarr <- iostrtoiointeger (ioread "a_onetol")
                             return $ (fromList (fromInteger (getn param)) (fromInteger (getm param)) (getsuba param  num iointarr))

fget_aone_tola:: Parameters -> Integer -> IO (Matrix (Integer))
fget_aone_tola param num = fmod param (fget_aone_tol param num)
--(fromList (fromInteger (getmb param)) (fromInteger (getw param)) ((chunksOf (getn param)*(getm param) iointarr))!!num)


--(fromList (fromInteger (getmb param)) (fromInteger (getw param)) ((chunksOf (getn param)*(getm param) (iointarr)))!!num)


--------------------------------------------------------

fget_arbar :: Parameters -> IO (Matrix (Integer))
fget_arbar param = do abar <- (fget_abar param)
                      rbar <- (fget_rbar param)
                      return $ (multStd  abar rbar)

fget_hg :: Parameters -> IO (Matrix (Integer))
fget_hg param = do h <- (fget_h param)
                   g <- (fget_g param)
                   return $ (multStd  h g)

fget_ar :: Parameters -> IO (Matrix (Integer))
fget_ar param = do a <- (fget_a param)
                   r <- (fget_r param)
                   return $ (multStd  a r)

minusinteger :: Parameters -> Integer -> Integer -> Integer
minusinteger param a b = mod (a-b) (getq param)

minusarr :: Parameters -> [Integer] -> [Integer] -> [Integer]
minusarr param arra arrb = loop 0 []
    where loop iter arr | iter < (length arra) = loop (iter +1) arr++[(minusinteger param (arra!!iter) (arrb!!iter))]
                        | otherwise = arr

minusmat :: Parameters -> (Matrix (Integer)) -> (Matrix (Integer)) -> (Matrix (Integer))
minusmat param mata matb = fromList (nrows mata ) (ncols mata) (minusarr param (Data.Matrix.toList mata) (Data.Matrix.toList matb))

minusiomat :: Parameters -> IO (Matrix (Integer)) -> IO (Matrix (Integer)) -> IO (Matrix (Integer))
minusiomat param iomata iomatb = do mata <- iomata
                                    matb <- iomatb
                                    return $ minusmat param mata matb


fget_secparta :: Parameters -> IO (Matrix (Integer))
fget_secparta param = fmod param (minusiomat param (fget_hg param)  (fget_arbar param))

fget_a :: Parameters -> IO (Matrix (Integer))
fget_a param = do a_i <- fget_abar param
                  a_ii <- (fget_secparta param)
                  return $ (a_i <|> a_ii)

--------------------------------------------------------
--fgenid

fgenidarr :: Integer -> [Integer]
fgenidarr size = loop 0 1 []
    where loop iter sq list | size*size>iter = if (iter+1==sq^2) then loop (iter+1) (sq+1) list++[1] else loop (iter+1) (sq) list++[0]
                         | otherwise = list



fgenid :: Integer -> Matrix (Integer)
fgenid a = fromList (fromInteger a) (fromInteger a) (fgenidarr a) 


returnmatrix :: [IO Integer] -> Integer -> Integer -> Matrix (IO Integer)
returnmatrix a b c = Data.Matrix.fromList (fromInteger b) (fromInteger c) a

fget_r :: Parameters -> IO (Matrix (Integer))
fget_r param = do rbar <- (fget_rbar param)
                  let id = (identity  (fromInteger (getw param)))
                  return $ rbar <-> id 
-----------------------------------------------------
fget_h :: Parameters -> IO (Matrix (Integer))
fget_h param = do  iointarr <- iostrtoiointeger (ioread "hh")
                   return $ (fromList (fromInteger (getn param)) (fromInteger (getn param)) (iointarr))
-----------------------------------------------------------
--this is for g

intarrtostr :: [Integer] -> String
intarrtostr arr = loop 0 ""
    where loop iter output | iter < (length arr) = loop (iter+1) output++"\n"++(show (arr!!iter))
                           | otherwise = output

--first gen string of gadget
fgen_g :: Parameters -> IO ()
fgen_g param = writeFile "g" (intarrtostr (getgarr param))


fgen_gg :: Parameters -> IO ()
fgen_gg param = writeFile "gg" (intarrtostr (getgarr (gen_parameters (getn param) ((getq param)*(getq param)))))

fget_gg :: Parameters -> IO (Matrix (Integer))
fget_gg param = do  iointarr <- iostrtoiointeger (ioread "gg")
                    return $ (fromList (fromInteger (getn param)) (fromInteger (getm param)) (iointarr))

fget_g :: Parameters -> IO (Matrix (Integer))
fget_g param = do  iointarr <- iostrtoiointeger (ioread "g")
                   return $ (fromList (fromInteger (getn param)) (fromInteger (getw param)) (iointarr))

checktozero :: Parameters -> IO (Matrix (Integer))
checktozero param = minusiomat param  (fget_ar param) (fget_hg param) 
---------------------------------------------------------------------------------------

--ioo:: IO Integer
--ioo =prandIntegerZeroToNMinusOne  1

--ioone:: IO Integer
--ioone =randIntegerOneToNMinusOne  2



stringrep :: Integer -> String -> String
stringrep rep input= loop 0 input
    where loop iter output | iter < rep = loop (iter+1) output++"\n"++input
                           | otherwise = output



addiostr :: IO String -> IO String -> IO String
addiostr a b = do aa <- a
                  bb <- b
                  return $ (aa++"\n"++bb)


--stringiointn :: Parameters -> Integer -> IO String
--stringiointn param num = loop 1 (stringioint param)
--    where loop iter string | iter<num = loop (iter+1) (addiostr string (stringioint param))
--                           | otherwise = string

writeri param name= do
    --a <- prandIntegerZeroToNMinusOne  5
    --b <- prandIntegerZeroToNMinusOne  5
    --writeFile "some-file.txt" (stringrep 10 (show (a)))
    output <-(stringiointn param 10)
    writeFile name output

--a_bar = (geta_bar param)

subtotals :: String -> [Int]
subtotals c = map sum (map (map readInt) (map words (lines c)))
    where
        readInt = read :: String -> Int

--iointstring :: [IO Integer] -> IO String
--iointstring arr = loop 1 (ioint2m (arr!!0))
--    where loop iter output | iter<(length arr) = loop (iter+1) output++(ioint2m (arr!!iter))
--                           | otherwise = output

--ioint2m :: IO Integer -> IO String
--ioint2m input = do
--                inp <-input
--                return $ (show inp)


saveArr = do
    outh <- openFile "test.txt" WriteMode
    hPrint outh [1,2,3]
    hClose outh


iowrite :: IO ()
iowrite = do
  c <- ioo--(Data.Matrix.toList (geta_bar ((Parameters 2 8 4 3))))
  writeFile "file.txt" (show c)



strarr2intarr :: [String] -> [Integer]
strarr2intarr strarr = loop 0 []
    where loop iter output | iter < (length strarr) = loop (iter+1) output++[(read (strarr!!iter))]
                           | otherwise = output

calc :: FilePath -> IO [Int]
calc fname = do
    contents <- readFile fname
    return $ subtotals contents
    --print $ sum (subtotals contents)

