module Wrapper
    ( 
    genvalues,
    encode_m,
    showciphertext,
    decode_m
    ) where


import Data.List.Split
import Param
import System.IO  
import Mtrx
import Exp
import Control.Monad
import Data.Matrix
import OpenSSL
import OpenSSL.BN
import File
import Data.Bits
import Decode


--to encode a message, create a file called (in the my-proj directory)
--         1. "m" with either 0 or 1 as your message bit
--         2. "x" with each line being either 0 or 1
--         1. "f" with each line being in format <operation> <input 1> <input 2>
--              a. <operation> is either 0 - which is addition 1 - which is multiplication 2 - is return
--              b. <input 1> and <input 2> are the elements that are entered in the gate

--this generates values
genvalues :: Integer  -> Integer -> IO()
genvalues q n = do let param = gen_parameters n q
                   fgen_abar param
                   nfullrankhb param
                   fgen_gg param
                   fgen_g param
                   fgen_rbar param
                   fgen_aone_tol param
                   fgen_u param
                   fgen_s param
                   --fgen_x param this will generate random attribute!! do not enable unless you know wat you're doing
                   fgen_pree param
                   fgen_preo param

--this splits the cipher test in cx1 and cx2
encode_m :: Integer  -> Integer -> IO()
encode_m q n = do let param = gen_parameters n q
                --a_bar <- fget_abar param
                --h <- fget_h param
                --g <- fget_g param
                --r_bar <- fget_rbar param
                  fgen_cx1 param    
                  fgen_cx2 param              

showciphertext :: Integer  -> Integer -> IO (Matrix (Integer))
showciphertext q n = do let param = gen_parameters n q
                        output <- (fget_cx param)
                        return $ output


decode_m :: Integer -> Integer -> IO Integer
decode_m q n = do let param = gen_parameters n q
                  message <- decode_c param
                  return $ message
                --fget_cx param












